USE [COWS]
GO
_CreateObject 'SP','dbo','getBillDsptchData'
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


-- =========================================================
-- Author:		jrg7298
-- Create date: 10/01/2019
-- Description:	Get all Billable Dispatch messages for prior month
--CUST_ID a.k.a H6
--CLEAR_LOC a.k.a Ticket Location
--DISP_CD a.k.a Disposition Code
--DISP_CAT_NAME a.k.a Ticket Category Name(Almost all the time-Customer)
--DISP_SUBCAT_NAME a.k.a Ticket SubCategory
--DISP_CA_NAME a.k.a Action Taken
--CLS_DT a.k.a CLEAR DATE
--TICK_NBR a.k.a SAMS Ticket #
-- =========================================================
ALTER PROCEDURE [dbo].[getBillDsptchData] --2
@Opt TINYINT = 1
AS
BEGIN
SET NOCOUNT ON;
Begin Try

IF OBJECT_ID(N'tempdb..#BDTbl', N'U') IS NOT NULL         
				DROP TABLE #BDTbl 

CREATE TABLE #BDTbl (ID INT IDENTITY(1,1) NOT NULL, [CUST_ID] [CHAR](9) NOT NULL,
	[CLEAR_LOC] VARCHAR(10) NOT NULL,
	[DISP_CD] [varchar](20) NOT NULL,
	[DISP_CAT_NAME] [varchar](50) NOT NULL,
	[DISP_SUBCAT_NAME] [varchar](255) NOT NULL,
	[DISP_CA_NAME] [varchar](255) NOT NULL,
	[CLS_DT] DATE NOT NULL,
	[TICK_NBR] [varchar](20) NOT NULL)

IF OBJECT_ID(N'tempdb..#UITbl', N'U') IS NOT NULL         
				DROP TABLE #UITbl 
				
CREATE TABLE #UITbl(
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[CUST_ID] [CHAR](9),
	[CLEAR_LOC] VARCHAR(10),
	[DISP_CD] [varchar](20),
	[DISP_CAT_NAME] [varchar](50),
	[DISP_SUBCAT_NAME] [varchar](255),
	[DISP_CA_NAME] [varchar](255),
	[CLS_DT] DATE,
	[TICK_NBR] [varchar](20),
	[ACPT_RJCT_CD] [CHAR](1),
	[ACPT_RJCT] [CHAR](10),
	[CMNT_TXT] [varchar](max),
	[STUS_ID] [int],
	[STUS_DES] varchar(1000),
	[CREAT_BY_USER_ID] [int],
	[CREAT_BY_USER_NME] [varchar](100),
	[MODFD_BY_USER_ID] [int],
	[MODFD_BY_USER_NME] [varchar](100),
	[CREAT_DT] [smalldatetime],
	[MODFD_DT] [smalldatetime])

INSERT INTO #BDTbl ([CUST_ID], [CLEAR_LOC], [DISP_CD], [DISP_CAT_NAME], [DISP_SUBCAT_NAME], [DISP_CA_NAME], [CLS_DT], [TICK_NBR])
SELECT * FROM OPENQUERY(TRP,'SELECT DISTINCT TICK_CUST.CUST_ID,
SUBSTR(TICK_CLEAR.LOC,1,4) AS CLEAR_LOC,
TICK_CLEAR.DISP_CD,
T_DISP_CAT.DISP_CAT_NAME,
T_DISP_SUBCAT.DISP_SUBCAT_NAME,
T_DISP_CA.DISP_CA_NAME,
TICK_CLEAR.CLEAR_DTTM, 
TICKET.TICK_NBR
FROM  TICKET INNER JOIN
TICK_CUST ON TICKET.TICK_NBR = TICK_CUST.TICK_NBR INNER JOIN
TICK_CLEAR ON (TICKET.TICK_NBR = TICK_CLEAR.TICK_NBR) AND (TICKET.LAST_CLR_SEQ = TICK_CLEAR.SEQ_NBR) INNER JOIN
T_EMPL ON TICK_CLEAR.EMPL_ID = T_EMPL.EMPL_ID INNER JOIN
T_DISP_CAT ON ((T_DISP_CAT.DISP_CAT)=SUBSTR(TICK_CLEAR.DISP_CD,1,2)) INNER JOIN
T_DISP_SUBCAT ON ((T_DISP_SUBCAT.DISP_SUBCAT)=SUBSTR(TICK_CLEAR.DISP_CD,1,4)) INNER JOIN
T_DISP_CA ON ((T_DISP_CA.DISP_CA)=SUBSTR(TICK_CLEAR.DISP_CD,(LENGTH(TICK_CLEAR.DISP_CD)-1),2))
WHERE (((TICK_CUST.SUB_SYS_TYPE)= ''L'') 
  AND (TICK_CUST.CUST_ID IS NOT NULL)
  AND (SUBSTR(TICK_CLEAR.LOC,1,4) In (''CSCT'',''ESCT'',''GDMN'',''IPOE'',''MNSD'',''MNSW'',''NCDC'',''SLPM'',''SPSC'')) 
  AND ((TICKET.CLR_BILL_FL)= ''Y'')
  AND ((TICK_CLEAR.CLEAR_DTTM between add_months(trunc(sysdate,''mm''),-1) and last_day(add_months(trunc(sysdate,''mm''),-1))))
  )
ORDER BY TICK_CLEAR.CLEAR_DTTM, TICKET.TICK_NBR')

IF (@Opt = 1) --Used by mach5sender
BEGIN
SELECT * FROM #BDTbl
END
ELSE IF (@Opt = 2) --Used by UI(Merge the pending billable records with the ones already present in db for the past month)
BEGIN
--Delete the tickets databased by the UI
DELETE bt
FROM #BDTbl bt
WHERE EXISTS (SELECT 'X' FROM dbo.[BILL_DSPTCH] bd WITH (NOLOCK) WHERE bd.[TICK_NBR]=bt.[TICK_NBR])

--Show any new Billable Dispatches after 8th business day on UI in Read-Only Mode, Comment here is system generated
INSERT INTO #UITbl ([CUST_ID], [CLEAR_LOC], [DISP_CD], [DISP_CAT_NAME], [DISP_SUBCAT_NAME], [DISP_CA_NAME], [CLS_DT], [TICK_NBR], [CMNT_TXT], [STUS_ID], [STUS_DES])
SELECT [CUST_ID], [CLEAR_LOC], [DISP_CD], [DISP_CAT_NAME], [DISP_SUBCAT_NAME], [DISP_CA_NAME], [CLS_DT], [TICK_NBR],
CASE WHEN (GETDATE() >= dbo.CalculateEndBusinessDate(FORMAT(GETDATE(),'yyyy-MM-01'),8)) THEN 'Missed 8th Business Day BillCycle' ELSE NULL END,
CASE WHEN (GETDATE() >= dbo.CalculateEndBusinessDate(FORMAT(GETDATE(),'yyyy-MM-01'),8)) THEN 244 ELSE NULL END,
CASE WHEN (GETDATE() >= dbo.CalculateEndBusinessDate(FORMAT(GETDATE(),'yyyy-MM-01'),8)) THEN (SELECT TOP 1 STUS_DES FROM dbo.LK_STUS WITH (NOLOCK) WHERE STUS_ID=244) ELSE NULL END
FROM #BDTbl

INSERT INTO #UITbl ([CUST_ID], [CLEAR_LOC], [DISP_CD], [DISP_CAT_NAME], [DISP_SUBCAT_NAME], [DISP_CA_NAME], [CLS_DT], [TICK_NBR], [ACPT_RJCT_CD], [ACPT_RJCT], [CMNT_TXT], [STUS_ID], [STUS_DES], 
[CREAT_BY_USER_ID], [CREAT_BY_USER_NME], [MODFD_BY_USER_ID], [MODFD_BY_USER_NME], [CREAT_DT], [MODFD_DT])
SELECT DISTINCT bd.[CUST_ID], bd.[CLEAR_LOC], bd.[DISP_CD], bd.[DISP_CAT_NAME], bd.[DISP_SUBCAT_NAME], bd.[DISP_CA_NAME], bd.[CLS_DT], bd.[TICK_NBR], bd.[ACPT_RJCT_CD], CASE WHEN bd.[ACPT_RJCT_CD] = 'A' THEN 'Accepted' WHEN bd.[ACPT_RJCT_CD] = 'R' THEN 'Rejected' ELSE '' END AS [ACPT_RJCT_CD], bd.[CMNT_TXT], bd.[STUS_ID], ls.[STUS_DES], 
bd.[CREAT_BY_USER_ID], luc.DSPL_NME as [CREAT_BY_USER_NME], bd.[MODFD_BY_USER_ID], lum.DSPL_NME as [MODFD_BY_USER_NME], bd.[CREAT_DT], bd.[MODFD_DT]
FROM dbo.BILL_DSPTCH bd WITH (NOLOCK) INNER JOIN
dbo.LK_STUS ls WITH (NOLOCK) ON ls.STUS_ID=bd.STUS_ID INNER JOIN
dbo.LK_USER luc WITH (NOLOCK) ON luc.[USER_ID]=bd.[CREAT_BY_USER_ID] LEFT JOIN
dbo.LK_USER lum WITH (NOLOCK) ON lum.[USER_ID]=bd.[MODFD_BY_USER_ID]
WHERE bd.[CLS_DT] BETWEEN DATEADD(MONTH,-1,FORMAT(GETDATE(),'yyyy-MM-01')) AND (CONVERT(DATETIME, EOMONTH(DATEADD(MONTH,-1,GETDATE()))) + CONVERT(DATETIME, '23:59:59'))

--IF NOT EXISTS (SELECT 'X' FROM #UITbl)
--BEGIN
	-- INSERT INTO #UITbl ([CUST_ID], [CLEAR_LOC], [DISP_CD], [DISP_CAT_NAME], [DISP_SUBCAT_NAME], [DISP_CA_NAME], [CLS_DT], [TICK_NBR])
	-- select [CUST_ID], [CLEAR_LOC], [DISP_CD], [DISP_CAT_NAME], [DISP_SUBCAT_NAME], [DISP_CA_NAME], [CLS_DT], [TICK_NBR] from (SELECT '928372946' as [CUST_ID],	'MNSW' as [CLEAR_LOC],	'456201' as [DISP_CD],	'CUSTOMER' as [DISP_CAT_NAME],	'FIBER / CABLE' as [DISP_SUBCAT_NAME],	'REPAIRED' as [DISP_CA_NAME],	'30-OCT-19' as [CLS_DT],	'4117113' as [TICK_NBR]
	-- UNION ALL
	-- SELECT '928634702' as [CUST_ID],	'MNSD' as [CLEAR_LOC],	'456529' as [DISP_CD],	'CUSTOMER' as [DISP_CAT_NAME],	'CPE' as [DISP_SUBCAT_NAME],	'NONE-CUSTOMER TO REPAIR' as [DISP_CA_NAME],	'30-OCT-19' as [CLS_DT],	'4173581' as [TICK_NBR]) as x where not exists (select 'x' from #UITbl ut where ut.TICK_NBR=x.TICK_NBR) 
--END

SELECT * FROM #UITbl

END
ELSE IF (@Opt = 3) --Return all Billable records so far in DB
BEGIN
INSERT INTO #UITbl ([CUST_ID], [CLEAR_LOC], [DISP_CD], [DISP_CAT_NAME], [DISP_SUBCAT_NAME], [DISP_CA_NAME], [CLS_DT], [TICK_NBR], [ACPT_RJCT_CD], [ACPT_RJCT], [CMNT_TXT], [STUS_ID], [STUS_DES], 
[CREAT_BY_USER_ID], [CREAT_BY_USER_NME], [MODFD_BY_USER_ID], [MODFD_BY_USER_NME], [CREAT_DT], [MODFD_DT])
SELECT DISTINCT bd.[CUST_ID], bd.[CLEAR_LOC], bd.[DISP_CD], bd.[DISP_CAT_NAME], bd.[DISP_SUBCAT_NAME], bd.[DISP_CA_NAME], bd.[CLS_DT], bd.[TICK_NBR], bd.[ACPT_RJCT_CD], CASE WHEN bd.[ACPT_RJCT_CD] = 'A' THEN 'Accepted' WHEN bd.[ACPT_RJCT_CD] = 'R' THEN 'Rejected' ELSE '' END AS [ACPT_RJCT_CD], bd.[CMNT_TXT], bd.[STUS_ID], ls.[STUS_DES], 
bd.[CREAT_BY_USER_ID], luc.DSPL_NME as [CREAT_BY_USER_NME], bd.[MODFD_BY_USER_ID], lum.DSPL_NME as [MODFD_BY_USER_NME], bd.[CREAT_DT], bd.[MODFD_DT]
FROM dbo.BILL_DSPTCH bd WITH (NOLOCK) INNER JOIN
dbo.LK_STUS ls WITH (NOLOCK) ON ls.STUS_ID=bd.STUS_ID INNER JOIN
dbo.LK_USER luc WITH (NOLOCK) ON luc.[USER_ID]=bd.[CREAT_BY_USER_ID] LEFT JOIN
dbo.LK_USER lum WITH (NOLOCK) ON lum.[USER_ID]=bd.[MODFD_BY_USER_ID]

SELECT * FROM #UITbl
END

End Try

Begin Catch
	EXEC [dbo].[insertErrorInfo]
End Catch
END